﻿////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Алгоритм отказывается от выгрузки некорректных документов расчетов в табличной части "Расшифровка платежа" в платежных документах. //
// Документ расчетов считается некорректным, если тип в БП документа расчета не соответствует типу в УТ для расчетного документа.     //
// Перечень несоответствующих типов определен в событии конвертации "Перед выгрузкой данных".                                         //
// в массиве МассивНекорректныхТиповДокументовРасчетов содержаться не корректные типы.                                                //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

МассивНекорректныхТиповДокументовРасчетов = Неопределено;
Если Параметры.СтруктураНевыгружаемыхДокументовРасчетов.Свойство(ТипДокументаРасчетов, МассивНекорректныхТиповДокументовРасчетов) Тогда
	Если МассивНекорректныхТиповДокументовРасчетов.Найти(ТипЗнч(ОбъектКоллекции[РеквизитДокументаРасчетов])) <> Неопределено Тогда
		Отказ = Истина;
	КонецЕсли;
КонецЕсли;

Если НЕ Отказ И ТипЗнч(ОбъектКоллекции[РеквизитДокументаРасчетов]) = Тип("ДокументСсылка.ПоступлениеТоваровУслуг") Тогда
	
	ДокументОбъект = ОбъектКоллекции[РеквизитДокументаРасчетов];
	
	Если ДокументОбъект.Склад.ВидСклада = Перечисления.ВидыСкладов.НеавтоматизированнаяТорговаяТочка Тогда
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		// В БП если в учетной политике организации указано, что "Способ оценки товаров в рознице" равен "По продажной стоимости" //
		// и вид склада на который поступает товар есть НТТ,                                                                      //
		// в этом случае документ в проводках фиксирует только сумму поступления на склад, товары игнорируются.                   //
		// Такой документ в УТ не переносится.                                                                                    //
		// Табличная часть "Услуги" или "Возвратная тара" не анализируется.                                                       //
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		мУчетнаяПолитика = ОбщегоНазначения.ПолучитьПараметрыУчетнойПолитики(ДокументОбъект.Дата, Ложь, ДокументОбъект.Организация);
		мУчетВПродажныхЦенах = Ложь;
		Если мУчетнаяПолитика.Количество() > 0 Тогда
			Если (мУчетнаяПолитика.СпособОценкиТоваровВРознице = Перечисления.СпособыОценкиТоваровВРознице.ПоПродажнойСтоимости) Тогда
				мУчетВПродажныхЦенах = Истина;
			КонецЕсли;
		КонецЕсли;
		
		РозницаВПродажныхЦенах = ((НЕ ДокументОбъект.Склад.ВидСклада = Перечисления.ВидыСкладов.Оптовый) 
									И мУчетВПродажныхЦенах 
									И (ДокументОбъект.ВидОперации = Перечисления.ВидыОперацийПоступлениеТоваровУслуг.ПокупкаКомиссия)
									И (НЕ ДокументОбъект.ДоговорКонтрагента.ВидДоговора = Перечисления.ВидыДоговоровКонтрагентов.СКомитентом));
									
		//---------------------
		Если РозницаВПродажныхЦенах Тогда
			Если Параметры.ДокументыПоступленияВозвратаТоваровВыгрузкаСсылки.Найти(ДокументОбъект, "ДокументПоступленияВозврата") = Неопределено Тогда
				Отказ = Истина;
			Иначе
				ИмяПКО = "ПоступлениеТоваровУслугВНТТ";
			КонецЕсли;
		Иначе
			ИмяПКО = "ПоступлениеТоваровУслугВНТТ";
		КонецЕсли;
	Иначе
		ИмяПКО = "ПоступлениеТоваровУслуг";
	КонецЕсли;

	Если ДокументОбъект.ВидОперации = Перечисления.ВидыОперацийПоступлениеТоваровУслуг.ВПереработку  Тогда
		Отказ = Истина;
	КонецЕсли;
ИначеЕсли НЕ Отказ И ТипЗнч(ОбъектКоллекции[РеквизитДокументаРасчетов]) = Тип("ДокументСсылка.ВозвратТоваровПоставщику") Тогда
	ДокументОбъект = ОбъектКоллекции[РеквизитДокументаРасчетов];
	Если ДокументОбъект.ВидОперации = Перечисления.ВидыОперацийВозвратТоваровПоставщику.ИзПереработки Тогда
		Отказ = Истина;
	Иначе
		Если ДокументОбъект.Склад.ВидСклада = Перечисления.ВидыСкладов.НеавтоматизированнаяТорговаяТочка Тогда
			////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			// В БП если в учетной политике организации указано, что "Способ оценки товаров в рознице" равен "По продажной стоимости" //
			// и вид склада на который поступает товар есть НТТ,                                                                      //
			// в этом случае документ в проводках фиксирует только сумму поступления на склад, товары игнорируются.                   //
			// Такой документ в УТ не переносится.                                                                                    //
			// Табличная часть "Услуги" или "Возвратная тара" не анализируется.                                                       //
			////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			
			мУчетнаяПолитика = ОбщегоНазначения.ПолучитьПараметрыУчетнойПолитики(ДокументОбъект.Дата, Ложь, ДокументОбъект.Организация);
			мУчетВПродажныхЦенах = Ложь;
			Если мУчетнаяПолитика.Количество() > 0 Тогда
				Если (мУчетнаяПолитика.СпособОценкиТоваровВРознице = Перечисления.СпособыОценкиТоваровВРознице.ПоПродажнойСтоимости) Тогда
					мУчетВПродажныхЦенах = Истина;
				КонецЕсли;
			КонецЕсли;
			РозницаВПродажныхЦенах = ((НЕ ДокументОбъект.Склад.ВидСклада = Перечисления.ВидыСкладов.Оптовый)
			И мУчетВПродажныхЦенах 
			И (ДокументОбъект.ВидОперации = Перечисления.ВидыОперацийВозвратТоваровПоставщику.ПокупкаКомиссия)
			И (НЕ ДокументОбъект.ДоговорКонтрагента.ВидДоговора = Перечисления.ВидыДоговоровКонтрагентов.СКомитентом));
			//---------------------
			Если РозницаВПродажныхЦенах Тогда
				Если Параметры.ДокументыПоступленияВозвратаТоваровВыгрузкаСсылки.Найти(ДокументОбъект, "ДокументПоступленияВозврата") = Неопределено Тогда
					Отказ = Истина;
				Иначе
					ИмяПКО = "ВозвратТоваровПоставщикуИзНТТ";
				КонецЕсли;
			Иначе
				ИмяПКО = "ВозвратТоваровПоставщикуИзНТТ";
			КонецЕсли;
		Иначе
			ИмяПКО = "ВозвратТоваровПоставщику";
		КонецЕсли;
	КонецЕсли;
ИначеЕсли НЕ Отказ
			И ТипЗнч(ОбъектКоллекции[РеквизитДокументаРасчетов]) = Тип("ДокументСсылка.РеализацияОтгруженныхТоваров")
			И ТипЗнч(ОбъектКоллекции[РеквизитДокументаРасчетов].ДокументОтгрузки) = Тип("ДокументСсылка.РеализацияТоваровУслуг") Тогда
	ИмяПКО = "РеализацияОтгруженныхТоваров";
ИначеЕсли НЕ Отказ
			И ТипЗнч(ОбъектКоллекции[РеквизитДокументаРасчетов]) = Тип("ДокументСсылка.РеализацияОтгруженныхТоваров")
			И ТипЗнч(ОбъектКоллекции[РеквизитДокументаРасчетов].ДокументОтгрузки) = Тип("ДокументСсылка.ПередачаОС") Тогда
	ИмяПКО = "ПередачаОСРеализацияОтгруженныхТоваров";
ИначеЕсли НЕ Отказ
			И ТипЗнч(ОбъектКоллекции[РеквизитДокументаРасчетов]) = Тип("ДокументСсылка.ПередачаОС")
			И ОбъектКоллекции[РеквизитДокументаРасчетов].ПравоСобственностиПереходитПослеГосРегистрации = Истина
	Тогда
	ИмяПКО = "ПередачаОСРеализацияОтгруженныхТоваров";
ИначеЕсли НЕ Отказ
			И ТипЗнч(ОбъектКоллекции[РеквизитДокументаРасчетов]) = Тип("ДокументСсылка.ПередачаОС")
			И ОбъектКоллекции[РеквизитДокументаРасчетов].ПравоСобственностиПереходитПослеГосРегистрации = Ложь
	Тогда
	ИмяПКО = "ПередачаОС";
КонецЕсли;
