﻿// Алгоритм получат из движений товарных документов, документы аванса которые погасил товарный документ.

//Для документов
//ПоступлениеТоваровУслугВНТТ
//ПоступлениеТоваровУслуг
//ОтчетКомиссионераОПродажах
//РеализацияТоваровУслуг
//ПоступлениеДопРасходов
//ВозвратТоваровПоставщику
//ПередачаОС
//ПоступлениеНМА
//ПередачаНМА
//АктОбОказанииПроизводственныхУслуг
//РеализацияОтгруженныхТоваров

//переменная НаименованиеТабличнойЧастиЗачетАвансов равна ".ЗачетАвансов"
//переменная НаименованиеРеквизитаДокументаРасчетов равна "ДокументАванса"

//Для документов
//	ВозвратТоваровОтПокупателя
//	ВозвратТоваровПоставщику
//переменная НаименованиеТабличнойЧастиЗачетАвансов равна "" обращение в запросе выполняется к шапке документа
//переменная НаименованиеРеквизитаДокументаРасчетов равна "Сделка"
	

Если Источник.ДоговорКонтрагента.ВидДоговора = Перечисления.ВидыДоговоровКонтрагентов.СКомитентом Тогда
	// Не выгружаются табличные части с документами зачета аванса по договору с комитентом, т.к. образование расчетных документов в УТ и БП КОРП различные)
	// В УТ задолженность по документу расчетов образовывает "Отчет комитенту о продаже товаров" сам же и является документом расчетов,
	// в БП это документ "Реализация товаров и услуг" и в качестве документа расчетов устанавливается поступление товаров.
	Отказ = Истина;
Иначе
	СтрокаУсловияДокументовРасчетов = "";
	Если НаименованиеТабличнойЧастиЗачетАвансов = "" ИЛИ Источник.СпособЗачетаАвансов = Перечисления.СпособыЗачетаАвансов.ПоДокументу Тогда
		СтрокаУсловияДокументовРасчетов = "
		|		Субконто1 В (
		|							ВЫБРАТЬ РАЗЛИЧНЫЕ
		|								ЗачетАвансов.ДокументАванса КАК ДокументАванса
		|							ИЗ
		|								ЗачетАвансов КАК ЗачетАвансов)
		|";
	КонецЕсли;
	ЕстьСубконтоДокументРасчетов = Ложь;
	МетаданныеИсточника = Источник.Метаданные();
	Если МетаданныеИсточника.Реквизиты.Найти(НаименованиеРеквизитаСчетаРасчетаПоАвансам) <> Неопределено И Источник[НаименованиеРеквизитаСчетаРасчетаПоАвансам].ВидыСубконто.Найти(ПланыВидовХарактеристик.ВидыСубконтоХозрасчетные.ДокументыРасчетовСКонтрагентами) <> Неопределено Тогда
		СчетУсловия = Источник[НаименованиеРеквизитаСчетаРасчетаПоАвансам];
		Запрос = Новый Запрос();
		Запрос.Текст = "
		|ВЫБРАТЬ РАЗЛИЧНЫЕ
		|	ЗачетАвансов." + НаименованиеРеквизитаДокументаРасчетов + " КАК ДокументАванса
		|ПОМЕСТИТЬ ЗачетАвансов
		|ИЗ
		|	Документ." + МетаданныеИсточника.Имя + НаименованиеТабличнойЧастиЗачетАвансов + " КАК ЗачетАвансов
		|ГДЕ
		|	ЗачетАвансов.Ссылка = &РегистраторДокумент
		|;
		|ВЫБРАТЬ
		|	ХозрасчетныйОбороты.Субконто1 КАК ДокументАванса,
		|	ХозрасчетныйОбороты.СуммаОборот" + ПрефиксОборота + " КАК СуммаРегл,
		|	ВЫБОР	КОГДА &ДоговорВВалютеРегУчета ТОГДА
		|			ХозрасчетныйОбороты.СуммаОборот" + ПрефиксОборота + "
		|			ИНАЧЕ ХозрасчетныйОбороты.ВалютнаяСуммаОборот" + ПрефиксОборота + "
		|	КОНЕЦ КАК СуммаВзаиморасчетов
		|ИЗ
		|	РегистрБухгалтерии.Хозрасчетный.Обороты(&ДатаНачала, &ДатаОкончания, Регистратор, Счет = &Счет, ЗНАЧЕНИЕ(ПланВидовХарактеристик.ВидыСубконтоХозрасчетные.ДокументыРасчетовСКонтрагентами),
		|	" + СтрокаУсловияДокументовРасчетов + "
		|	, , ) КАК ХозрасчетныйОбороты
		|ГДЕ
		|	ХозрасчетныйОбороты.Регистратор = &РегистраторДокумент
		|";
		ДоговорВВалютеРегУчета = (Источник.ДоговорКонтрагента.ВалютаВзаиморасчетов = Константы.ВалютаРегламентированногоУчета.Получить());
		Запрос.УстановитьПараметр("РегистраторДокумент", Источник.Ссылка);
		Запрос.УстановитьПараметр("Счет", СчетУсловия);
		Запрос.УстановитьПараметр("ДатаНачала", Источник.Дата);
		Запрос.УстановитьПараметр("ДатаОкончания", Источник.Дата);
		Запрос.УстановитьПараметр("ДоговорВВалютеРегУчета", ДоговорВВалютеРегУчета);
		КоллекцияОбъектов = Запрос.Выполнить().Выгрузить();
	Иначе
		Отказ = Истина;
	КонецЕсли;
КонецЕсли;
