﻿// Алгоритм удаляет не корректные строки из табличной части "Зачет аванса" в товарных документах.
// Строка считается не корректной, если тип в БП документа аванса не соответствует типу в УТ для расчетного документа.
// Перечень несоответствующих типов определен в событии конвертации "Перед выгрузкой данных".
// в массиве МассивНекорректныхТиповДокументовРасчетов содержаться не корректные типы.

МассивНекорректныхТиповДокументовРасчетов = Неопределено;
Если НЕ Параметры.СтруктураНевыгружаемыхДокументовРасчетов.Свойство(ТипДокументаРасчетов, МассивНекорректныхТиповДокументовРасчетов) Тогда
	МассивНекорректныхТиповДокументовРасчетов = Новый Массив();
КонецЕсли;

итератор = 0;
Пока итератор <= КоллекцияОбъектов.Количество() - 1 Цикл
	СтрокаКоллекцияОбъектов = КоллекцияОбъектов.Получить(итератор);
	Если МассивНекорректныхТиповДокументовРасчетов.Найти(ТипЗнч(СтрокаКоллекцияОбъектов[РеквизитДокументаРасчетов])) <> Неопределено Тогда
		КоллекцияОбъектов.Удалить(итератор);
	ИначеЕсли ТипЗнч(СтрокаКоллекцияОбъектов[РеквизитДокументаРасчетов]) = Тип("ДокументСсылка.ПоступлениеТоваровУслуг") Тогда
		ОтказВыгрузки = Ложь;
		ДокументОбъект = СтрокаКоллекцияОбъектов[РеквизитДокументаРасчетов];

		Если ДокументОбъект.Склад.ВидСклада = Перечисления.ВидыСкладов.НеавтоматизированнаяТорговаяТочка Тогда
			
			// В БП если в учетной политике организации указано, что "Способ оценки товаров в рознице" равен "По продажной стоимости"
			// и вид склада на который поступает товар есть НТТ,
			// в этом случае документ в проводках фиксирует только сумму поступления на склад, товары игнорируются.
			// Такой документ в УТ не переносится.
			// Табличная часть "Услуги" или "Возвратная тара" не анализируется.
			мУчетнаяПолитика = ОбщегоНазначения.ПолучитьПараметрыУчетнойПолитики(ДокументОбъект.Дата, Ложь, ДокументОбъект.Организация);
			мУчетВПродажныхЦенах = Ложь;
			Если мУчетнаяПолитика.Количество() > 0 Тогда
				Если (мУчетнаяПолитика.СпособОценкиТоваровВРознице = Перечисления.СпособыОценкиТоваровВРознице.ПоПродажнойСтоимости) Тогда
					мУчетВПродажныхЦенах = Истина;
				КонецЕсли;
			КонецЕсли;
			
			РозницаВПродажныхЦенах = ((НЕ ДокументОбъект.Склад.ВидСклада = Перечисления.ВидыСкладов.Оптовый) 
										И мУчетВПродажныхЦенах 
										И (ДокументОбъект.ВидОперации = Перечисления.ВидыОперацийПоступлениеТоваровУслуг.ПокупкаКомиссия)
										И (НЕ ДокументОбъект.ДоговорКонтрагента.ВидДоговора = Перечисления.ВидыДоговоровКонтрагентов.СКомитентом));
										
			//---------------------							
			Если РозницаВПродажныхЦенах Тогда
				ОтказВыгрузки = Истина;
			КонецЕсли;
		КонецЕсли;

		Если ДокументОбъект.ВидОперации = Перечисления.ВидыОперацийПоступлениеТоваровУслуг.ВПереработку  Тогда
			ОтказВыгрузки = Истина;
		КонецЕсли;
		
		Если ОтказВыгрузки Тогда
			КоллекцияОбъектов.Удалить(итератор);
		Иначе
			итератор = итератор + 1;
		КонецЕсли;
	Иначе
		итератор = итератор + 1;
	КонецЕсли;
	
КонецЦикла;
